#include "2d_physics_object.h"

PhysicsObject2D::PhysicsObject2D()
{
	m_position.x = 0;
	m_position.y = 0;
	_rotation = 0.0f;
	m_collider = NULL;
	m_rigidbody = NULL;
}

PhysicsObject2D::PhysicsObject2D(const PhysicsObject2D& other)
{
}

PhysicsObject2D::~PhysicsObject2D()
{
}

bool PhysicsObject2D::Initialize(Vector2 in_position, float mass, string tag, int radius)
{
	float area;

	_objectTag = tag;

	m_position = in_position;
	_potentialPosition = m_position;

	m_rigidbody = new Rigidbody2D;
	if (!m_rigidbody)
	{
		return false;
	}

	area = F_PI * (radius * radius);

	m_rigidbody->Initialize(mass, Vector2(0.0f, 0.0f), area);

	m_collider = new BoundingCircle;
	if (!m_collider)
	{
		return false;
	}

	static_cast<BoundingCircle*>(m_collider)->InitializeBoundingCircle(radius, Vector2(0.f, 0.f));

	return true;
}

bool PhysicsObject2D::Initialize(Vector2 in_position, float mass, string tag, int width, int height)
{
	float area;

	_objectTag = tag;
	m_position = in_position;
	_potentialPosition = m_position;

	m_rigidbody = new Rigidbody2D;
	if (!m_rigidbody)
	{
		return false;
	}

	area = width * height;

	m_rigidbody->Initialize(mass, Vector2(0.0f, 0.0f), area);

	m_collider = new BoundingBox;
	if (!m_collider)
	{
		return false;
	}

	static_cast<BoundingBox*>(m_collider)->InitializeBoundingBox(width, height, Vector2(0.f, 0.f));

	return true;
}

void PhysicsObject2D::Shutdown()
{
	if (m_rigidbody)
	{
		delete m_rigidbody;
		m_rigidbody = NULL;
	}

	if (m_collider)
	{
		delete m_collider;
		m_collider = NULL;
	}
}