#include "BufferParser.h"

void ParseFloat(char* buffer, int& bufferPosition, float& output)
{
	bool isNegative = false;
	int mantissa = 0.0f;
	float exponent = 0.0f;
	int exponent_size = 0;
	char input;

	//Check if the number is a negative number
	input = buffer[bufferPosition];
	if (input == '-')
	{
		isNegative = true;
		bufferPosition++;
	}

	//Read in the 'mantissa'
	input = buffer[bufferPosition];
	while (input != '.')
	{
		mantissa = (mantissa * 10) + (input - '0');
		bufferPosition++;
		input = buffer[bufferPosition];
	}
	bufferPosition++;

	//Read in the 'exponent'
	input = buffer[bufferPosition];
	while (input > 47 && input <58)
	{
		exponent_size++;
		exponent = (exponent * 10) + (input - '0');
		bufferPosition++;
		input = buffer[bufferPosition];
	}

	if (exponent > 0 && exponent_size>0)
	{
		exponent = exponent * pow(10, -exponent_size);
	}

	output = (float)mantissa + exponent;
	if (isNegative)
		output = -output;
}

void ParseCharArray(char* buffer, int& bufferPosition, char*& output)
{
	int tempPosition, string_length;
	char input;

	tempPosition = bufferPosition;
	
	string_length = 0;
	//Get the length of the object filename
	input = buffer[bufferPosition];
	while (input > 33)
	{
		string_length++;
		tempPosition++;
		input = buffer[tempPosition];
	}

	output = new char[string_length+1];

	int string_pos = 0;

	//Read in the object filename
	input = buffer[bufferPosition];
	while (input > 33)
	{
		output[string_pos] = buffer[bufferPosition];
		bufferPosition++;
		string_pos++;
		input = buffer[bufferPosition];
	}
	output[string_length] = '\0';
}

void ParseBoolean(char* buffer, int& bufferPosition, bool& output)
{
	char input;

	input = buffer[bufferPosition];
	output = input - '0';
	bufferPosition += 2;
}

void ParseInt(char* buffer, int& bufferPosition, int& output)
{
	char input;
	bool isNegative = false;
	
	output = 0;

	//Check if the number is a negative number
	input = buffer[bufferPosition];
	if (input == '-')
	{
		isNegative = true;
		bufferPosition++;
	}

	input = buffer[bufferPosition];
	while (input > 47 && input <58)
	{
		output = (output * 10) + (input - '0');
		bufferPosition++;
		input = buffer[bufferPosition];
	}

	if (isNegative)
		output = -output;
}

void ParseToData(char* buffer, int& bufferPosition)
{
	char input;

	input = buffer[bufferPosition];
	while (input < 33)
	{
		bufferPosition++;
		input = buffer[bufferPosition];
	}
}