#include "animated_sprite.h"

void AnimatedSprite::UpdateAnimation(float dt)
{
	total_dt_ += dt;

	if (total_dt_ >= (1.0f / anim_speed))
	{
		uv_position_.x += uv_width_;
		current_frame++;
		if (uv_position_.x > (num_frames - 1) * uv_width_)
		{
			current_frame = 0;
			uv_position_.x = 0;
			num_cycles++;
		}
		total_dt_ -= (1.0f / anim_speed);
	}
	/*
	if ((anim_frame_count++) % (int)(anim_frame_count/anim_speed) == 0)
	{
		
	}
	*/
	

}

AnimatedSprite::~AnimatedSprite()
{
}

void AnimatedSprite::SwapAnimation(int anim_num)
{
	anim_frame_count = 0;
	uv_position_.y = 0;

	uv_position_.x = (anim_num - 1) * uv_width_;
}

void AnimatedSprite::LoadTexture(char* filename, abfw::Platform& platform)
{
	abfw::PNGLoader png_loader;
	abfw::PNGLoader img_ldr;
	abfw::ImageData image_data;

	img_ldr.Load(filename, platform, image_data);

	if (image_data.image() == NULL)
	{
		std::cout << "Image failed to load." << std::endl;
		exit(-1);
	}

	set_texture(platform.CreateTexture(image_data));
}


void AnimatedSprite::Render(abfw::SpriteRenderer* sprite_renderer, abfw::Font& font)
{
	if (visible_)
		sprite_renderer->DrawSprite(*this);
}