#include "area_hazard.h"

void AreaHazard::LoadUniqueData(char* buffer, int& bufferPosition)
{
	//Load in the damage and damage frequency variables
	ParseFloat(buffer, bufferPosition, damage_);
	bufferPosition+=2;

	ParseFloat(buffer, bufferPosition, damageFrequency_);
	bufferPosition+=2;

	trigger_ = new BoxTrigger;

	static_cast<BoxTrigger*>(trigger_)->Initialize(object_body_->GetWorld(), "PlayerObject", object_body_->GetPosition().x, object_body_->GetPosition().y, ABFW_BOX2D_SIZE(width_) / 2, ABFW_BOX2D_SIZE(height_) / 2);
}

bool AreaHazard::Frame(float dt)
{
	GameObject* target;

	target = NULL;

	target = (GameObject*)trigger_->Triggered();

	if (target)
	{
		if (time_since_trigger_ >= damageFrequency_)
		{
			if (target->TakeDamage(damage_))
			{
				time_since_trigger_ = 0.0f;
				return true;
			}

			time_since_trigger_ += dt;
		}
		else
		{
			time_since_trigger_ += dt;
		}
	}

	return false;
}
