#include "audio_source.h"

void AudioSource::SetSampleVolume(float sample_volume)
{
	if (sample_id_ != -1)
	{
		sample_volume_ = sample_volume;
	}
}

void AudioSource::SetSamplePan(float sample_pan)
{
	if (sample_id_ != -1)
	{
		sample_pan_ = sample_pan;
	}
}

void AudioSource::SetSamplePitch(float sample_pitch)
{
	if (sample_id_ != -1)
	{
		sample_pitch_ = sample_pitch;
		
	}
}

Int32 AudioSource::GetId()
{
	return sample_id_;
}

void AudioSource::LoadUniqueData(char* buffer, int& bufferPosition)
{
	char* audioFilename;

	//Load in the audio filename
	ParseCharArray(buffer, bufferPosition, audioFilename);
	bufferPosition++;

	//Load in the volume, pitch and pan
	ParseFloat(buffer, bufferPosition, sample_volume_);
	bufferPosition++;

	ParseFloat(buffer, bufferPosition, sample_pitch_);
	bufferPosition++;

	ParseFloat(buffer, bufferPosition, sample_pan_);
	bufferPosition++;

	//Load looping
	ParseBoolean(buffer, bufferPosition, looping_);
	bufferPosition++;

	LoadSoundData(audioFilename);
}

void AudioSource::ToggleLooping()
{
	looping_ = !looping_;
}