#ifndef _AUDIO_SOURCE_H_
#define _AUDIO_SOURCE_H_

#include <audio\vita\audio_manager_vita.h>
#include <system/application.h>
#include "button_trigger.h"
#include "game_object.h"

class AudioSource : public GameObject
{
public:
	virtual void Initialize(abfw::AudioManagerVita* audio_manager, abfw::Platform* platform, Trigger* trigger) = 0;
	virtual void Frame() = 0;
	virtual void Stop() = 0;
	virtual void Shutdown() = 0;
	virtual void PlaySound() = 0;

	void SetSampleVolume(float sample_volume);
	void SetSamplePan(float sample_pan);
	void SetSamplePitch(float sample_pitch);
	void ToggleLooping();
	Int32 GetId();

	virtual void LoadSoundData(char* soundFilename) = 0;

private:
	void LoadUniqueData(char* buffer, int& bufferPosition);
	

protected:
	abfw::AudioManagerVita* audio_manager_;
	abfw::Platform* platform_;
	float sample_volume_;
	float sample_pan_;
	float sample_pitch_;
	Trigger* trigger_;
	bool looping_;
	Int32 sample_id_;
	Int32 sample_voice_;
};

#endif