#ifndef _BUTTON_TRIGGER_H_
#define _BUTTON_TRIGGER_H_

#include "trigger.h"
#include "inputclass.h"
#include "game_object.h"

class ButtonTrigger : public Trigger
{
public:
	~ButtonTrigger(){}

	inline void Initialize(InputClass* input, UInt32 trigger_buttons)
	{
		input_ = input;
		trigger_buttons_ = trigger_buttons;
	};

	void* Triggered()
	{
		if (input_->IsButtonPressed(trigger_buttons_))
		{
			bool return_value = true;
			return &return_value;
		}
		else
		{
			return NULL;
		}
	}

	inline void SetConnectedObject(GameObject* connected_object)
	{
		connected_object_ = connected_object;
	}

private:
	InputClass* input_;
	UInt32 trigger_buttons_;
	GameObject* connected_object_;
};

#endif