#ifndef _ENEMY_OBJECT_H_
#define _ENEMY_OBJECT_H_

#include "game_object.h"
#include "animation_object.h"
#include "weapon_object.h"

class EnemyObject : public GameObject
{
public:
	EnemyObject()
	{
		typeTag_ = "EnemyObject";
	}

	void Frame(b2Vec2 player_position, float dt);
	bool TakeDamage(float damage_amount_);
	void LoadUniqueData(char* buffer, int& bufferPosition);
	void Render(abfw::SpriteRenderer* sprite_renderer, abfw::Font& font);
	void Shutdown();

	float GetDeathAnimationTime();
private:
	float health_;
	int integer_health_;
	int max_health_;
	float fire_rate_;
	float total_dt_ = 0;
	char* animation_filename_;
	AnimationObject* death_animation_;
	char* weapon_filename_;
	WeaponObject* weapon_;
	float attack_range_;

};

#endif