#ifndef _FONT_OBJECT_H_
#define _FONT_OBJECT_H_

#include <graphics/font.h>
#include <maths/vector3.h>

#include <string>

using std::string;

class FontObject
{
public:
	FontObject(abfw::Vector3 position, float scale, UInt32 colour, abfw::TextJustification justification, char* text, bool hidden)
	{
		position_ = position;
		scale_ = scale;
		colour_ = colour;
		justification_ = justification;
		text_ = text;
		hidden_ = hidden;
	}

	inline void SetPosition(abfw::Vector3 position)
	{
		position_ = position;
	}

	inline abfw::Vector3 GetPosition()
	{
		return position_;
	}

	inline void SetScale(float scale)
	{
		scale_ = scale;
	}

	inline float GetScale()
	{
		return scale_;
	}

	inline void SetColour(UInt32 colour)
	{
		colour_ = colour;
	}

	inline UInt32 GetColour()
	{
		return colour_;
	}

	inline void SetJustification(abfw::TextJustification justification)
	{
		justification_ = justification;
	}

	inline abfw::TextJustification GetJustification()
	{
		return justification_;
	}

	inline void SetText(char* text)
	{
		text_ = text;
	}

	inline char* GetText()
	{
		return text_;
	}

	inline void ToggleHide()
	{
		if (hidden_)
		{
			hidden_ = false;
		}
		else
		{
			hidden_ = true;
		}
	}

	inline bool IsHidden()
	{
		return hidden_;
	}

private:
	abfw::Vector3 position_;
	float scale_;
	UInt32 colour_;
	abfw::TextJustification justification_;
	char* text_;
	bool hidden_;
};


#endif