#ifndef _FORCES_H_
#define _FORCES_H_

const float  F_PI = 3.14159265;

#include <math.h>
#include <cmath>

#include "utility_maths.h"

struct DirectForce
{
	float x_comp;
	float y_comp;

	float x_offset;
	float y_offset;

	float angle;
	float magnitude;

	DirectForce(float x_component, float y_component, float x_off, float y_off);
};

void CalculateResultantForce(DirectForce& output, DirectForce force1, DirectForce force2);
float CalculateAngularAcceleration(DirectForce force, float inertia);

#endif