#include "kinematic_animation.h"

KinematicAnimation::KinematicAnimation()
{
	start_joint.joint_position = abfw::Vector2(0.0f, 0.0f);
	end_joint.joint_position = abfw::Vector2(0.0f, 0.0f);
}

KinematicAnimation::KinematicAnimation(const KinematicAnimation& other)
{
}

KinematicAnimation::~KinematicAnimation()
{
}

bool KinematicAnimation::Initialize(abfw::Vector2 point, float bone_one_length, float bone_two_length)
{
	bone_one.bone_length = bone_one_length;
	bone_two.bone_length = bone_two_length;

	start_joint.joint_position = point;
	mid_joint.joint_position = abfw::Vector2(point.x, point.y - bone_one.bone_length);
	end_joint.joint_position = abfw::Vector2(point.x, point.y - (bone_one.bone_length + bone_two.bone_length));

	return true;
}

void KinematicAnimation::Frame()
{
	abfw::Vector2 temp_vector;
	float angle, a, b, c;

	CalculateMidPoint();

	bone_one.start_position = start_joint.joint_position;
	bone_one.end_position = mid_joint.joint_position;
	temp_vector = (bone_one.end_position - bone_one.start_position);
	c = temp_vector.Length();
	a = bone_one.bone_length / 2;
	b = bone_one.bone_length / 2;
	angle = acos(((a*a) + (b*b) - (c*c)) / (2 * a * b));
	bone_one.bone_sprite.set_rotation(angle);

	bone_two.start_position = mid_joint.joint_position;
	bone_two.end_position = end_joint.joint_position;
	temp_vector = (bone_two.end_position - bone_two.start_position);
	c = temp_vector.Length();
	a = bone_two.bone_length / 2;
	b = bone_two.bone_length / 2;
	angle = acos(((a*a) + (b*b) - (c*c)) / (2 * a * b));
	bone_two.bone_sprite.set_rotation(angle);
}

void KinematicAnimation::Shutdown()
{

}

void KinematicAnimation::CalculateMidPoint()
{
	float angle, a, b, c;
	abfw::Vector2 main_vector, edge_vector;

	a = bone_one.bone_length;
	b = bone_two.bone_length;
	c = (end_joint.joint_position - start_joint.joint_position).Length();

	angle = acos(((b*b) + (c*c) - (a*a))/(2 * b * c));

	main_vector = (end_joint.joint_position - start_joint.joint_position);

	main_vector.Normalise();

	edge_vector.x = (main_vector.x * cos(angle)) + (main_vector.y * sin(angle));
	edge_vector.y = (main_vector.x * -sin(angle)) + (main_vector.y * cos(angle));

	mid_joint.joint_position = edge_vector * bone_one.bone_length;
}

