#include "object_storage.h"

void ObjectStorage::Initialize()
{
	m_terrain = new TerrainObject;
	m_player = new PlayerObject;
	m_hazard = new AreaHazard;
	m_enemy = new EnemyObject;
	m_animation = new AnimationObject;
}

bool ObjectStorage::SetObjectType(GameObject*& object, char* target_type)
{
	if (strcmp(target_type, m_terrain->typeTag_) == 0)
	{
		object = new TerrainObject;
		return true;
	}

	if (strcmp(target_type, m_player->typeTag_) == 0)
	{
		object = new PlayerObject;
		return true;
	}

	if (strcmp(target_type, m_hazard->typeTag_) == 0)
	{
		object = new AreaHazard;
		return true;
	}

	if (strcmp(target_type, m_enemy->typeTag_) == 0)
	{
		object = new EnemyObject;
		return true;
	}

	if (strcmp(target_type, m_animation->typeTag_) == 0)
	{
		object = new AnimationObject;
		return true;
	}

	return false;
}