#ifndef _OPTIONS_SCENE_H_
#define _OPTIONS_SCENE_H_

#include <string>

#include "base_scene_class.h"
#include "ui_button.h"
#include "ui_text.h"

class OptionsScene : public BaseSceneClass
{
public:
	bool Initialize(Platform* platform, abfw::AudioManagerVita* audio_manager, InputClass* input, abfw::SpriteRenderer* renderer, abfw::Font& font, OptionsStorage* options_storage, const char* filename);
	
	int Frame(float dt);
	void Shutdown();

	void Render(abfw::SpriteRenderer* renderer_, abfw::Font& font);

public:
	int returnValue_;

private:
	UIButton* volumeLeftButton_;
	UIButton* volumeRightButton_;
	UIButton* controlLeftButton_;
	UIButton* controlRightButton_;
	UIButton* difficultyLeftButton_;
	UIButton* difficultyRightButton_;
	
	ControlEnum current_control_ = BOOST;
};

#endif