#include "options_storage.h"

void OptionsStorage::Initialize(abfw::AudioManagerVita* audio_manager)
{
	audio_manager_ = audio_manager;

	ChangeControlSetting(BOOST, ABFW_SONY_CTRL_L2);
	ChangeControlSetting(FIRE, ABFW_SONY_CTRL_R2);

	SetMasterVolume(1.0f);

	level_count_ = 2;

	level_names_.push_back("test_level.LEVEL");
	level_names_.push_back("hard_level.LEVEL");

	current_level_ = 1;
}

void OptionsStorage::ChangeControlSetting(int control, UInt32 new_button)
{
	control_configs_[control] = new_button;
}

UInt32 OptionsStorage::GetControlSetting(int control)
{
	return control_configs_[control];
}

void OptionsStorage::SetMasterVolume(float master_volume)
{
	master_volume_ = master_volume;

	audio_manager_->SetMasterVolume(master_volume_);
}

float OptionsStorage::GetMasterVolume()
{
	return master_volume_;
}

const char* OptionsStorage::GetLevelName(int level_num)
{
	return level_names_[level_num - 1];
}

int OptionsStorage::GetCurrentLevel()
{
	return current_level_;
}

int OptionsStorage::GetLevelCount()
{
	return level_count_;
}

void OptionsStorage::SetCurrentLevel(int level_num)
{
	current_level_ = level_num;
}