#ifndef _OPTIONS_STORAGE_H_
#define _OPTIONS_STORAGE_H_

#include <audio\vita\audio_manager_vita.h>
#include "inputclass.h"
#include <vector>

enum ControlEnum
{
	BOOST, HOVER, FIRE, ALT_FIRE, EQUIPMENT_SWITCH
};


class OptionsStorage
{
public:
	void Initialize(abfw::AudioManagerVita* audio_manager);

	void ChangeControlSetting(int control, UInt32 new_button);
	UInt32 GetControlSetting(int control);

	void SetMasterVolume(float master_volume);
	float GetMasterVolume();

	const char* GetLevelName(int level_num);
	
	int GetCurrentLevel();
	void SetCurrentLevel(int level_num);
	int GetLevelCount();
private:
	UInt32 control_configs_[5];
	float master_volume_;
	abfw::AudioManagerVita* audio_manager_;
	int level_count_, current_level_;
	std::vector<const char*> level_names_;
};

#endif