#ifndef _SCENECLASS_H_
#define _SCENECLASS_H_

#include <assets\png_loader.h>
#include <graphics\image_data.h>
#include <Box2D\Box2D.h>

#include "base_scene_class.h"
#include "object_storage.h"
#include "BufferParser.h"
#include "ui_value_bar.h"
#include "audio_music.h"


class SceneClass : public BaseSceneClass
{
public:
	SceneClass();
	SceneClass(const SceneClass& other);
	~SceneClass();

	bool Initialize(Platform* platform, abfw::AudioManagerVita* audio_manager, InputClass* input, abfw::SpriteRenderer* renderer, abfw::Font& font, OptionsStorage* options_storage, const char* filename);
	int Frame(float dt);
	void Shutdown();
	void Render(abfw::SpriteRenderer* renderer_, abfw::Font& font);

	void DeleteObject(GameObject* object);
	GameObject* InstantiateObject(GameObject* object, float posX, float posY, float rot);

private:
	void LoadSceneFile(abfw::SpriteRenderer* renderer, abfw::Font& font, const char* filename);
	void ResetLevel();
	void ObjectFrame(GameObject* current_object);

public:
	std::list<GameObject*> delete_list_;
	int enemy_count_ = 0;
	float end_timer_ = 0.0f;

private:
	b2World* physics_world_;
	abfw::Vector2 start_position_;
	PlayerObject* player_ptr_;
	float timer_;
	float current_dt_;
	bool end_of_level_;
	ObjectStorage m_objectStore;
	b2Vec2 camera_position_;	
};

#endif