#include "static_scene.h"


bool StaticScene::Initialize(Platform* platform, abfw::AudioManagerVita* audio_manager, InputClass* input, abfw::SpriteRenderer* renderer, abfw::Font& font, OptionsStorage* options_storage, const char* scene_text)
{
	platform_ = platform;

	input_ = input;

	audio_manager_ = audio_manager;

	options_storage_ = options_storage;

	UIText* text = new UIText;

	text->Initialize(scene_text, 0xFF990099, 480, 180, 6);

	ui_objects_.push_back(text);

	background_image_ = new AnimatedSprite;

	background_image_->LoadTexture("background.png", *platform);
	background_image_->set_width(1024);
	background_image_->set_height(1024);
	background_image_->set_position(abfw::Vector3(platform->width() / 2, platform->height() / 2, 0.9f));

	display_time_ = 3.0f;

	return true;
}

void StaticScene::Shutdown()
{
	platform_ = NULL;
	input_ = NULL;
}

int StaticScene::Frame(float dt)
{
	total_dt_ += dt;

	if (total_dt_ >= display_time_)
	{
		total_dt_ -= display_time_;
		return 0;
	}
	
	return returnValue_;
}

void StaticScene::SetReturnValue(int returnValue)
{
	returnValue_ = returnValue;
}