#ifndef _TITLE_SCENE_CLASS_H_
#define _TITLE_SCENE_CLASS_H_

#include "base_scene_class.h"

#include "ui_button.h"
#include "ui_text.h"
#include "audio_music.h"

class TitleSceneClass :public BaseSceneClass
{
public:
	TitleSceneClass();
	TitleSceneClass(const TitleSceneClass& other);
	~TitleSceneClass();

	bool Initialize(Platform* platform, abfw::AudioManagerVita* audio_manager, InputClass* input, abfw::SpriteRenderer* renderer, abfw::Font& font, OptionsStorage* options_storage, const char* filename);
	int Frame(float dt);
	void Shutdown();
	void RestartMusic();

private:
	UIButton* play_button_;
	UIButton* options_button_;
	AudioMusic ambience_music_;
};

#endif