#include "ui_button.h"

void UIButton::Initialize(abfw::Platform& platform, char* textureFilename, InputClass* input, int posX, int posY, int width, int height, bool animated)
{
	if (textureFilename)
	{
		LoadTexture(textureFilename, platform);
	}

	animated_ = animated;

	positionX_ = posX;
	positionY_ = posY;

	_width = width;
	_height = height;

	if (animated_)
		set_uv_width(0.5f);
	
	set_position(abfw::Vector3(posX, posY, -0.9f));

	set_width(width);
	set_height(height);

	input_ = input;
}

bool UIButton::Frame(float dt)
{
	float posX, posY;

	set_uv_position(abfw::Vector2(0.0f, 0.0f));

	if (input_->IsTouchDown(0, 0))
	{
		input_->GetNewTouchPosition(0, 0, posX, posY);

		bool x_check = ((posX >= positionX_ - _width) && (posX <= positionX_ + _width));
		bool y_check = ((posY >= positionY_ - _height) && (posY <= positionY_ + _height));

		if (x_check && y_check)
		{
			if (animated_)
				set_uv_position(abfw::Vector2(0.5f, 0.0f));
			return true;
		}

	}
}