#include "vector2.h"

Vector2::Vector2()
{
}

Vector2::~Vector2()
{
}

Vector2::Vector2(const Vector2& other)
{
	x = other.x;
	y = other.y;
}

Vector2::Vector2(const float _x, const float _y)
{
	x = _x;
	y = _y;
}

const Vector2 Vector2::operator-(const Vector2& vec)
{
	Vector2 result;

	result.x = x - vec.x;
	result.y = y - vec.y;

	return result;
}

const Vector2 Vector2::operator+(const Vector2& vec)
{
	Vector2 result;

	result.x = x + vec.x;
	result.y = y + vec.y;

	return result;
}

Vector2& Vector2::operator+=(const Vector2& vec)
{
	x += vec.x;
	y += vec.y;

	return *this;
}

Vector2& Vector2::operator-=(const Vector2& vec)
{
	x -= vec.x;
	y -= vec.y;

	return *this;
}

const Vector2 Vector2::operator*(const float scalar)
{
	Vector2 result;

	result.x = x * scalar;
	result.y = y * scalar;

	return result;
}

const Vector2 Vector2::operator/(const float scalar)
{
	Vector2 result;

	result.x = x / scalar;
	result.y = y / scalar;

	return result;
}

Vector2& Vector2::operator*=(const float scalar)
{
	x *= scalar;
	y *= scalar;

	return *this;
}

Vector2& Vector2::operator/=(const float scalar)
{
	x /= scalar;
	y /= scalar;

	return *this;
}

const float Vector2::Length()
{
	float length;

	length = sqrt((x*x) + (y*y));

	return length;
}

const Vector2 Vector2::Normalize()
{
	Vector2 result;
	float length;
	
	length = Length();

	result.x = x / length;
	result.y = y / length;

	return result;
}

const float Vector2::Cross(const Vector2& vec)
{
	float result;

	result = (x * vec.y) - (y * vec.x);

	return result;
}

const float Vector2::Dot(const Vector2& vec)
{
	float result;

	result = (x*vec.x) + (y*vec.y);

	return result;
}

