#ifndef _VECTOR2_H_
#define _VECTOR2_H_

#include <math.h>

class Vector2
{
public:
	Vector2();
	Vector2(const Vector2& other);
	~Vector2();
	Vector2(const float x, const float y);

	const Vector2 operator - (const Vector2& vec);
	const Vector2 operator + (const Vector2& vec);
	Vector2& operator -= (const Vector2& vec);
	Vector2& operator += (const Vector2& vec);
	const Vector2 operator * (const float scalar);
	const Vector2 operator / (const float scalar);
	Vector2& operator *= (const float scalar);
	Vector2& operator /= (const float scalar);

	const float Length();
	const Vector2 Normalize();
	
	const float Cross(const Vector2& vec);
	const float Dot(const Vector2& vec);

	float x;
	float y;

};

#endif