#ifndef _WEAPON_OBJECT_H_
#define _WEAPON_OBJECT_H_

#include "game_object.h"
#include "projectile_object.h"
#include "audio_sfx.h"

class WeaponObject : public GameObject
{
public:
	WeaponObject()
	{
		typeTag_ = "WeaponObject";
	}

	void Frame(b2Vec2 position, b2Vec2 camera_position, float rotation, float dt);
	void LoadUniqueData(char* buffer, int& bufferPosition);
	void Fire();
	void Shutdown();

private:
	bool firing_;
	ProjectileObject* projectile_;
	AudioSfx shot_sound_effect_;
	int num_barrages_, num_projectiles_;
	float projectile_angle_, barrage_rate_, fire_rate_, weapon_force_;
	int barrages_fired_;
	float cooldown_time_ = 0.0f, barrage_time_ = 0.0f;
	float weapon_rotation_;
	uint16 target_filter_;
};

#endif